package com.thaiopensource.pullax;

import java.util.Map;

/**
 * Represents an XML DTD.
 */
public interface XmlDtd {

  /**
   * The returned Map must be unmodifiable.
   * Maps from a name to an XmlElementType.
   */
  Map getElementTypes();

  /**
   * The returned Map must be unmodifiable.
   * Maps from the name of a notation to its XmlExternalId.
   */
  Map getNotations();

  /**
   * The returned Map must be unmodifiable.
   * Maps from the name of a notation to an XmlEntity.
   */
  Map getGeneralEntities();

  String getInternalSubset();
  
  XmlExternalId getExternalId();

  boolean allDeclarationsProcessed();

  XmlScanner scanProcessingInstructions();
}
