package com.thaiopensource.pullax;

import java.util.Locale;

public class XmlReportException extends XmlException {
  private final XmlReport report;

  public XmlReportException(XmlReport report) {
    super(report.getMessage());
    this.report = report;
  }

  public XmlLocation getLocation() {
    return report.getLocation();
  }

  public XmlSeverity getSeverity() {
    return report.getSeverity();
  }

  public XmlReport getReport() {
    return report;
  }

  public String format(Locale locale) {
    return XmlReportFormat.getInstance(locale).format(report);
  }

  public String format() {
    return format(Locale.getDefault());
  }

  public String toString() {
    return getClass().getName() + ": " + format();
  }
}
