package com.thaiopensource.pullax;

import java.io.IOException;

/**
 * Interface for scanning an XML document. This class models an
 * XML document as a sequence of items.  The scanner allows this
 * sequence to be scanned once only, in forwards order.
 *
 * @author James Clark
 */
public interface XmlScanner {
  /**
   * Returns the next item.
   *
   * @return an XmlItem for the next item
   * @throws IOException if an I/O error occurs
   */
  XmlContentItem nextItem() throws IOException;

  boolean hasMoreItems() throws IOException;

  /**
   * Releases resources associated with this <code>XmlScanner</code>.
   *
   * @throws java.io.IOException if an I/O error occurs
   */
  void close() throws IOException;
}
