package com.thaiopensource.pullax;

import java.util.Enumeration;

public class XmlScannerFactoryFinder {
  static private Service service;

  public static XmlScannerFactory findScannerFactory(XmlFeature[] features)
    throws XmlNotSupportedException {
    synchronized (XmlScannerFactoryFinder.class) {
      if (service == null)
	service = new Service(XmlScannerFactory.class);
    }
    for (Enumeration enum = service.getProviders();
	 enum.hasMoreElements();) {
      XmlScannerFactory factory = ((XmlScannerFactory)enum.nextElement()).copy();
      try {
	factory.setFeatures(features);
	return factory;
      }
      catch (XmlNotSupportedException e) { }
    }
    throw new XmlNotSupportedException();
  }

  public static XmlScannerFactory findScannerFactory() throws XmlNotSupportedException {
    return findScannerFactory(new XmlFeature[0]);
  }
}
