package com.thaiopensource.pullax.xni;

import java.util.HashMap;
import java.util.Map;
import java.util.Collections;
import java.util.List;
import java.util.ArrayList;

import com.thaiopensource.pullax.XmlDtd;
import com.thaiopensource.pullax.XmlContentItem;
import com.thaiopensource.pullax.XmlExternalId;
import com.thaiopensource.pullax.XmlScanner;

class Dtd implements XmlDtd {
  private Map elementTypes = new HashMap();
  private Map notations = new HashMap();
  private Map generalEntities = new HashMap();
  private List processingInstructions = new ArrayList();
  private String internalSubset;
  private final XmlExternalId externalId;

  Dtd(XmlExternalId externalId) {
    this.externalId = externalId;
  }

  void freeze() {
    elementTypes = Collections.unmodifiableMap(elementTypes);
    notations = Collections.unmodifiableMap(notations);
    generalEntities = Collections.unmodifiableMap(generalEntities);
  }

  public Map getElementTypes() {
    return elementTypes;
  }

  public Map getNotations() {
    return notations;
  }

  public Map getGeneralEntities() {
    return generalEntities;
  }

  void setInternalSubset(String s) {
    internalSubset = s;
  }

  public String getInternalSubset() {
    return internalSubset;
  }
  
  public XmlExternalId getExternalId() {
    return externalId;
  }

  public boolean allDeclarationsProcessed() {
    return true;
  }

  public XmlScanner scanProcessingInstructions() {
    return new IteratorScanner(processingInstructions.iterator());
  }

  void addProcessingInstruction(XmlContentItem item) {
    processingInstructions.add(item);
  }
}
