package com.thaiopensource.pullax.xni;

import com.thaiopensource.pullax.XmlNotSupportedException;
import com.thaiopensource.pullax.XmlFeature;

class FeatureSet {
  protected boolean showEmptyElement;
  protected boolean showCdataSection;
  protected boolean showProcessingInstruction;
  protected boolean showComment;
  protected boolean showDocumentEntity;
  protected boolean showExternalEntity;
  protected boolean showInternalEntity;
  protected boolean showUnexpandedEntityReference;
  protected boolean showBuiltinEntityReference;
  protected boolean showCharacterReference;
  protected boolean showDocumentType;
  protected boolean showTopLevelWhitespace;
  protected boolean allowSplitText;
  protected boolean preserveAttributeOrder;
  protected boolean skipExternalGeneralEntities;

  protected FeatureSet() {
  }

  protected FeatureSet(FeatureSet fs) {
    showEmptyElement = fs.showEmptyElement;
    showCdataSection = fs.showCdataSection;
    showProcessingInstruction = fs.showProcessingInstruction;
    showComment = fs.showComment;
    showDocumentEntity = fs.showDocumentEntity;
    showExternalEntity = fs.showExternalEntity;
    showInternalEntity = fs.showInternalEntity;
    showUnexpandedEntityReference = fs.showUnexpandedEntityReference;
    showBuiltinEntityReference = fs.showBuiltinEntityReference;
    showCharacterReference = fs.showCharacterReference;
    showDocumentType = fs.showDocumentType;
    showTopLevelWhitespace = fs.showTopLevelWhitespace;
    allowSplitText = fs.allowSplitText;
    preserveAttributeOrder = fs.preserveAttributeOrder;
    skipExternalGeneralEntities = fs.skipExternalGeneralEntities;
  }

  protected void clear() {
    showEmptyElement = false;
    showCdataSection = false;
    showProcessingInstruction = false;
    showComment = false;
    showDocumentEntity = false;
    showExternalEntity = false;
    showInternalEntity = false;
    showUnexpandedEntityReference = false;
    showBuiltinEntityReference = false;
    showCharacterReference = false;
    showDocumentType = false;
    showTopLevelWhitespace = false;
    allowSplitText = false;
    preserveAttributeOrder = false;
    skipExternalGeneralEntities = false;
  }

  protected void setFeatures(XmlFeature[] features) throws XmlNotSupportedException {
    clear();
    for (int i = 0; i < features.length; i++)
      addFeature(features[i]);
  }

  protected void addShowEmptyElement()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowCdataSection()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowProcessingInstruction()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowComment()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowDocumentEntity()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowExternalEntity()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowInternalEntity()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowUnexpandedEntityReference()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowBuiltinEntityReference()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowCharacterReference()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowDocumentType()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addShowTopLevelWhitespace()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addAllowSplitText()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addPreserveAttributeOrder()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected void addSkipExternalGeneralEntities()
    throws XmlNotSupportedException {
    throw new XmlNotSupportedException();
  }

  protected boolean hasFeature(XmlFeature feature) {
    if (feature == XmlFeature.SHOW_EMPTY_ELEMENT)
      return showEmptyElement;
    else if (feature == XmlFeature.SHOW_CDATA_SECTION)
      return showCdataSection;
    else if (feature == XmlFeature.SHOW_PROCESSING_INSTRUCTION)
      return showProcessingInstruction;
    else if (feature == XmlFeature.SHOW_COMMENT)
      return showComment;
    else if (feature == XmlFeature.SHOW_DOCUMENT_ENTITY)
      return showDocumentEntity;
    else if (feature == XmlFeature.SHOW_EXTERNAL_ENTITY)
      return showExternalEntity;
    else if (feature == XmlFeature.SHOW_INTERNAL_ENTITY)
      return showInternalEntity;
    else if (feature == XmlFeature.SHOW_UNEXPANDED_ENTITY_REFERENCE)
      return showUnexpandedEntityReference;
    else if (feature == XmlFeature.SHOW_BUILTIN_ENTITY_REFERENCE)
      return showBuiltinEntityReference;
    else if (feature == XmlFeature.SHOW_CHARACTER_REFERENCE)
      return showCharacterReference;
    else if (feature == XmlFeature.SHOW_DOCUMENT_TYPE)
      return showDocumentType;
    else if (feature == XmlFeature.SHOW_TOP_LEVEL_WHITESPACE)
      return showTopLevelWhitespace;
    else if (feature == XmlFeature.ALLOW_SPLIT_TEXT)
      return allowSplitText;
    else if (feature == XmlFeature.PRESERVE_ATTRIBUTE_ORDER)
      return preserveAttributeOrder;
    else if (feature == XmlFeature.SKIP_EXTERNAL_GENERAL_ENTITIES)
      return skipExternalGeneralEntities;
    else
      return false;
  }

  protected void addFeature(XmlFeature feature) throws XmlNotSupportedException {
    if (feature == XmlFeature.SHOW_EMPTY_ELEMENT)
      addShowEmptyElement();
    else if (feature == XmlFeature.SHOW_CDATA_SECTION)
      addShowCdataSection();
    else if (feature == XmlFeature.SHOW_PROCESSING_INSTRUCTION)
      addShowProcessingInstruction();
    else if (feature == XmlFeature.SHOW_COMMENT)
      addShowComment();
    else if (feature == XmlFeature.SHOW_DOCUMENT_ENTITY)
      addShowDocumentEntity();
    else if (feature == XmlFeature.SHOW_EXTERNAL_ENTITY)
      addShowExternalEntity();
    else if (feature == XmlFeature.SHOW_INTERNAL_ENTITY)
      addShowInternalEntity();
    else if (feature == XmlFeature.SHOW_UNEXPANDED_ENTITY_REFERENCE)
      addShowUnexpandedEntityReference();
    else if (feature == XmlFeature.SHOW_BUILTIN_ENTITY_REFERENCE)
      addShowBuiltinEntityReference();
    else if (feature == XmlFeature.SHOW_CHARACTER_REFERENCE)
      addShowCharacterReference();
    else if (feature == XmlFeature.SHOW_DOCUMENT_TYPE)
      addShowDocumentType();
    else if (feature == XmlFeature.SHOW_TOP_LEVEL_WHITESPACE)
      addShowTopLevelWhitespace();
    else if (feature == XmlFeature.ALLOW_SPLIT_TEXT)
      addAllowSplitText();
    else if (feature == XmlFeature.PRESERVE_ATTRIBUTE_ORDER)
      addPreserveAttributeOrder();
    else if (feature == XmlFeature.SKIP_EXTERNAL_GENERAL_ENTITIES)
      addSkipExternalGeneralEntities();
    else
      throw new XmlNotSupportedException();
  }
}
