package com.thaiopensource.pullax.xni;

import com.thaiopensource.pullax.XmlContentItem;
import com.thaiopensource.pullax.XmlContext;
import com.thaiopensource.pullax.XmlLocation;
import com.thaiopensource.pullax.XmlAttributeItem;

abstract class ItemBase implements XmlContentItem, XmlLocation {
  private final int lineNumber;
  private final int columnNumber;
  private Context context;

  ItemBase(Context context, Position position) {
    this.context = context;
    this.lineNumber = position.lineNumber;
    this.columnNumber = position.columnNumber;
  }

  Position getPosition() {
    Position position = new Position();
    position.lineNumber = this.lineNumber;
    position.columnNumber = this.columnNumber;
    return position;
  }

  final void setInternalContext(Context context) {
    this.context = context;
  }

  final Context getInternalContext() {
    return context;
  }

  public String getName() {
    return null;
  }

  public String getLocalName() {
    return null;
  }

  public String getPrefix() {
    return null;
  }

  public String getNamespaceUri() {
    return null;
  }

  public String getValue() {
    return null;
  }

  public int getAttributeCount() {
    return 0;
  }

  public XmlAttributeItem getAttribute(int i) {
    throw new IndexOutOfBoundsException();
  }

  public XmlAttributeItem getAttribute(String namespaceUri, String localName) {
    return null;
  }

  public XmlAttributeItem getAttribute(String localName) {
    return getAttribute(null, localName);
  }

  public XmlLocation getLocation() {
    return this;
  }

  public String getUri() {
    return context.getSourceUri();
  }

  public int getLineNumber() {
    return lineNumber;
  }

  public int getColumnNumber() {
    return columnNumber;
  }

  public XmlContext getContext() {
    return context;
  }
  
}
