package com.thaiopensource.pullax.xni;

import java.util.Iterator;

import com.thaiopensource.pullax.XmlScanner;
import com.thaiopensource.pullax.XmlContentItem;

/**
 * Implements an XmlScanner in terms of an Iterator.
 */
class IteratorScanner implements XmlScanner {
  private final Iterator iter;

  IteratorScanner(Iterator iter) {
    this.iter = iter;
  }

  public XmlContentItem nextItem() {
    return (XmlContentItem)iter.next();
  }

  public boolean hasMoreItems() {
    return iter.hasNext();
  }

  public void close() { }
}
