package com.thaiopensource.pullax.xni;

import com.thaiopensource.pullax.XmlLocation;
import org.apache.xerces.xni.XMLLocator;

final class LocationImpl implements XmlLocation {
  private final String uri;
  private final int lineNumber;
  private final int columnNumber;

  LocationImpl(XMLLocator loc) {
    this.uri = loc.getSystemId();
    this.lineNumber = loc.getLineNumber();
    this.columnNumber = loc.getColumnNumber();
  }

  public String getUri() {
    return uri;
  }

  public int getLineNumber() {
    return lineNumber;
  }

  public int getColumnNumber() {
    return columnNumber;
  }
}
