package com.thaiopensource.pullax.xni;

import org.apache.xerces.xni.QName;

abstract class NamedItem extends ItemBase {
  private final String rawname;
  private final String localpart;
  private final String prefix;
  private final String uri;

  NamedItem(Context context, Position position, QName q) {
    super(context, position);
    rawname = q.rawname;
    localpart = q.localpart;
    prefix = nullify(q.prefix);
    uri = nullify(q.uri);
  }

  static private String nullify(String s) {
    return "".equals(s) ? null : s;
  }

  public String getName() {
    return rawname;
  }

  public String getLocalName() {
    return localpart;
  }

  public String getPrefix() {
    return prefix;
  }

  public String getNamespaceUri() {
    return uri;
  }
}
