package com.thaiopensource.pullax.xni;

import java.io.IOException;
import java.util.Locale;

import com.thaiopensource.pullax.XmlScanner;
import com.thaiopensource.pullax.XmlScannerFactory;
import com.thaiopensource.pullax.XmlInputSource;
import com.thaiopensource.pullax.XmlFeature;
import com.thaiopensource.pullax.XmlEntityResolver;
import com.thaiopensource.pullax.XmlReporter;
import com.thaiopensource.pullax.XmlNotSupportedException;

import org.apache.xerces.parsers.StandardParserConfiguration;

public class ScannerFactory extends FeatureSet implements XmlScannerFactory {
  private XmlEntityResolver resolver;
  private XmlReporter reporter;
  private Locale locale;

  public ScannerFactory() {
  }

  public ScannerFactory(ScannerFactory that) {
    super(that);
    this.resolver = resolver;
    this.reporter = reporter;
  }

  public XmlScanner createScanner(XmlInputSource input) throws IOException {
    return new XmlScannerImpl(new StandardParserConfiguration(), input, this, locale,
			      resolver, reporter);
  }

  public void setFeatures(XmlFeature[] features) throws XmlNotSupportedException {
    super.setFeatures(features);
  }

  public void addFeature(XmlFeature feature) throws XmlNotSupportedException {
    super.addFeature(feature);
  }

  public boolean hasFeature(XmlFeature feature) {
    return super.hasFeature(feature);
  }

  public void setEntityResolver(XmlEntityResolver resolver) {
    this.resolver = resolver;
  }

  public XmlEntityResolver getEntityResolver() {
    return resolver;
  }

  public void setReporter(XmlReporter reporter) {
    this.reporter = reporter;
  }

  public XmlReporter getReporter() {
    return reporter;
  }

  public XmlScannerFactory copy() {
    return new ScannerFactory(this);
  }

  // supported features

  protected void addShowEmptyElement() {
    showEmptyElement = true;
  }

  protected void addShowCdataSection() {
    showCdataSection = true;
  }

  protected void addShowProcessingInstruction() {
    showProcessingInstruction = true;
  }

  protected void addShowComment() {
    showComment = true;
  }

  protected void addShowDocumentEntity() {
    showDocumentEntity = true;
  }

  protected void addShowExternalEntity() {
    showExternalEntity = true;
  }

  protected void addShowInternalEntity() {
    showInternalEntity = true;
  }

  protected void addShowBuiltinEntityReference() {
    showBuiltinEntityReference = true;
  }

  protected void addShowCharacterReference() {
    showCharacterReference = true;
  }

  protected void addShowDocumentType() {
    showDocumentType = true;
  }

  protected void addAllowSplitText() {
    allowSplitText = true;
  }

  public void setLocale(Locale locale) {
    this.locale = locale;
  }

  public Locale getLocale() {
    return locale;
  }

}
