package com.thaiopensource.pullax.xni;

import org.apache.xerces.xni.QName;
import org.apache.xerces.xni.XMLAttributes;

import com.thaiopensource.pullax.XmlAttributeItem;

class StartElementItem extends NamedItem {
  private final AttributeItem[] attributes;

  StartElementItem(Context context, Position position, QName q, XMLAttributes attributes) {
    super(context, position, q);
    this.attributes = new AttributeItem[attributes.getLength()];
    for (int i = 0; i < this.attributes.length; i++)
      this.attributes[i] = new AttributeItem(this, attributes, i);
  }

  public int getItemType() {
    return START_ELEMENT;
  }
  
  public int getAttributeCount() {
    return attributes.length;
  }

  public XmlAttributeItem getAttribute(int i) {
    return attributes[i];
  }

}
